package com.fuyuanshen.app.service.impl;

import com.fuyuanshen.common.core.utils.MapstructUtils;
import com.fuyuanshen.common.mybatis.core.page.TableDataInfo;
import com.fuyuanshen.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import com.fuyuanshen.app.domain.bo.AppDeviceBindRecordBo;
import com.fuyuanshen.app.domain.vo.AppDeviceBindRecordVo;
import com.fuyuanshen.app.domain.AppDeviceBindRecord;
import com.fuyuanshen.app.mapper.AppDeviceBindRecordMapper;
import com.fuyuanshen.app.service.IAppDeviceBindRecordService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 设备绑定关系Service业务层处理
 *
 * @author Lion Li
 * @date 2025-07-28
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class AppDeviceBindRecordServiceImpl implements IAppDeviceBindRecordService {

    private final AppDeviceBindRecordMapper baseMapper;

    /**
     * 查询设备绑定关系
     *
     * @param id 主键
     * @return 设备绑定关系
     */
    @Override
    public AppDeviceBindRecordVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询设备绑定关系列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 设备绑定关系分页列表
     */
    @Override
    public TableDataInfo<AppDeviceBindRecordVo> queryPageList(AppDeviceBindRecordBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<AppDeviceBindRecord> lqw = buildQueryWrapper(bo);
        Page<AppDeviceBindRecordVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的设备绑定关系列表
     *
     * @param bo 查询条件
     * @return 设备绑定关系列表
     */
    @Override
    public List<AppDeviceBindRecordVo> queryList(AppDeviceBindRecordBo bo) {
        LambdaQueryWrapper<AppDeviceBindRecord> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<AppDeviceBindRecord> buildQueryWrapper(AppDeviceBindRecordBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<AppDeviceBindRecord> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(AppDeviceBindRecord::getId);
        lqw.eq(bo.getDeviceId() != null, AppDeviceBindRecord::getDeviceId, bo.getDeviceId());
        lqw.eq(bo.getBindingUserId() != null, AppDeviceBindRecord::getBindingUserId, bo.getBindingUserId());
        lqw.eq(bo.getBindingTime() != null, AppDeviceBindRecord::getBindingTime, bo.getBindingTime());
        lqw.eq(bo.getCommunicationMode() != null, AppDeviceBindRecord::getCommunicationMode, bo.getCommunicationMode());
        return lqw;
    }

    /**
     * 新增设备绑定关系
     *
     * @param bo 设备绑定关系
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(AppDeviceBindRecordBo bo) {
        AppDeviceBindRecord add = MapstructUtils.convert(bo, AppDeviceBindRecord.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改设备绑定关系
     *
     * @param bo 设备绑定关系
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(AppDeviceBindRecordBo bo) {
        AppDeviceBindRecord update = MapstructUtils.convert(bo, AppDeviceBindRecord.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(AppDeviceBindRecord entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除设备绑定关系信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public Long checkDeviceExistBindRecord(Long deviceId) {
        return baseMapper.checkDeviceExistBindRecord(deviceId);
    }
}
